package test.glib.models;


import net.sf.latexdraw.glib.models.impl.LShapeFactory;
import net.sf.latexdraw.glib.models.interfaces.DrawingTK;
import net.sf.latexdraw.glib.models.interfaces.IAxes;

import org.junit.Before;
import org.junit.Test;

import test.glib.models.interfaces.TestIAxes;

public class TestLAxes<T extends IAxes> extends TestIAxes<T> {
	@SuppressWarnings("unchecked")
	@Override
	@Before
	public void setUp() {
		DrawingTK.setFactory(new LShapeFactory());
		shape  = (T) DrawingTK.getFactory().createAxes(false, DrawingTK.getFactory().createPoint());
		shape2 = (T) DrawingTK.getFactory().createAxes(false, DrawingTK.getFactory().createPoint());
	}


	@Test
	public void testConstructor3() {
		IAxes axes = DrawingTK.getFactory().createAxes(false, DrawingTK.getFactory().createPoint(10, -20));

		assertNotNull(axes.getPtAt(0));
		assertEquals(10., axes.getPtAt(0).getX());
		assertEquals(-20., axes.getPtAt(0).getY());
		axes = DrawingTK.getFactory().createAxes(false, null);
		assertNotNull(axes.getPtAt(0));
		assertEquals(0., axes.getPtAt(0).getX());
		assertEquals(0., axes.getPtAt(0).getY());
		axes = DrawingTK.getFactory().createAxes(true, null);
		assertNotNull(axes.getPtAt(0));
		assertEquals(0., axes.getPtAt(0).getX());
		assertEquals(0., axes.getPtAt(0).getY());
		axes = DrawingTK.getFactory().createAxes(false, DrawingTK.getFactory().createPoint(Double.NaN, 0));
		assertNotNull(axes.getPtAt(0));
		assertEquals(0., axes.getPtAt(0).getX());
		assertEquals(0., axes.getPtAt(0).getY());
		axes = DrawingTK.getFactory().createAxes(true, DrawingTK.getFactory().createPoint(0, Double.NaN));
		assertNotNull(axes.getPtAt(0));
		assertEquals(0., axes.getPtAt(0).getX());
		assertEquals(0., axes.getPtAt(0).getY());
		axes = DrawingTK.getFactory().createAxes(false, DrawingTK.getFactory().createPoint(Double.POSITIVE_INFINITY, 0));
		assertNotNull(axes.getPtAt(0));
		assertEquals(0., axes.getPtAt(0).getX());
		assertEquals(0., axes.getPtAt(0).getY());
	}
}
