package test.glib.models;


import net.sf.latexdraw.glib.models.impl.LShapeFactory;
import net.sf.latexdraw.glib.models.interfaces.DrawingTK;
import net.sf.latexdraw.glib.models.interfaces.IDot;

import org.junit.Before;
import org.junit.Test;

import test.glib.models.interfaces.TestIDot;

public class TestLDot<T extends IDot> extends TestIDot<T> {
	@SuppressWarnings("unchecked")
	@Override
	@Before
	public void setUp() {
		DrawingTK.setFactory(new LShapeFactory());
		shape  = (T) DrawingTK.getFactory().createDot(DrawingTK.getFactory().createPoint(), false);
		shape2 = (T) DrawingTK.getFactory().createDot(DrawingTK.getFactory().createPoint(), false);
	}


	@Test
	public void testConstructor1() {
		IDot dot1 = DrawingTK.getFactory().createDot(DrawingTK.getFactory().createPoint(), false);

		assertTrue(dot1.getRadius()>0);
		assertNotNull(dot1.getDotStyle());
		assertNotNull(dot1.getPosition());
		assertEquals(0., dot1.getPosition().getX());
		assertEquals(0., dot1.getPosition().getY());
	}


	@Test
	public void testConstructor3() {
		IDot dot1 = DrawingTK.getFactory().createDot(null, false);

		assertTrue(dot1.getRadius()>0);
		assertNotNull(dot1.getDotStyle());
		assertNotNull(dot1.getPosition());
		assertEquals(0., dot1.getPosition().getX());
		assertEquals(0., dot1.getPosition().getY());

		dot1 = DrawingTK.getFactory().createDot(DrawingTK.getFactory().createPoint(-1, 2), true);
		assertEquals(-1., dot1.getPosition().getX());
		assertEquals(2., dot1.getPosition().getY());
	}
}
