package test.glib.models;


import net.sf.latexdraw.glib.models.impl.LShapeFactory;
import net.sf.latexdraw.glib.models.interfaces.DrawingTK;
import net.sf.latexdraw.glib.models.interfaces.IFreehand;

import org.junit.Before;
import org.junit.Test;

import test.glib.models.interfaces.TestIFreehand;

public class TestLFreeHand<T extends IFreehand> extends TestIFreehand<T> {
	@SuppressWarnings("unchecked")
	@Override
	@Before
	public void setUp() {
		DrawingTK.setFactory(new LShapeFactory());
		shape  = (T) DrawingTK.getFactory().createFreeHand(DrawingTK.getFactory().createPoint(), false);
		shape2 = (T) DrawingTK.getFactory().createFreeHand(DrawingTK.getFactory().createPoint(), false);
	}


	@Test
	public void testConstructorsWithValidPoint() {
		final IFreehand fh = DrawingTK.getFactory().createFreeHand(DrawingTK.getFactory().createPoint(), false);
		assertNotNull(fh);
	}

	@Test
	public void testConstructorsWithNotValidPoint() {
		try {
			DrawingTK.getFactory().createFreeHand(null, false);
			fail();
		}catch(IllegalArgumentException e) { /* ok */ }
	}
}
