package test.glib.models;


import net.sf.latexdraw.glib.models.impl.LShapeFactory;
import net.sf.latexdraw.glib.models.interfaces.DrawingTK;
import net.sf.latexdraw.glib.models.interfaces.IGrid;

import org.junit.Before;
import org.junit.Test;

import test.glib.models.interfaces.TestIGrid;

public class TestLGrid<T extends IGrid> extends TestIGrid<T> {
	@SuppressWarnings("unchecked")
	@Override
	@Before
	public void setUp() {
		DrawingTK.setFactory(new LShapeFactory());
		shape  = (T) DrawingTK.getFactory().createGrid(false, DrawingTK.getFactory().createPoint());
		shape2 = (T) DrawingTK.getFactory().createGrid(false, DrawingTK.getFactory().createPoint());
	}


	@Test
	public void testConstructors() {
		IGrid grid = DrawingTK.getFactory().createGrid(false, DrawingTK.getFactory().createPoint());
		assertTrue(grid.getGridEndX()>=grid.getGridStartX());
		assertTrue(grid.getGridEndY()>=grid.getGridStartY());
		assertEquals(0., grid.getPosition().getX());
		assertEquals(0., grid.getPosition().getY());
	}
}
