package test.glib.models;

import junit.framework.TestCase;
import net.sf.latexdraw.glib.models.impl.LShapeFactory;
import net.sf.latexdraw.glib.models.interfaces.DrawingTK;
import net.sf.latexdraw.glib.models.interfaces.IAxes;
import net.sf.latexdraw.glib.models.interfaces.IBezierCurve;
import net.sf.latexdraw.glib.models.interfaces.ICircle;
import net.sf.latexdraw.glib.models.interfaces.ICircleArc;
import net.sf.latexdraw.glib.models.interfaces.IDot;
import net.sf.latexdraw.glib.models.interfaces.IEllipse;
import net.sf.latexdraw.glib.models.interfaces.IFreehand;
import net.sf.latexdraw.glib.models.interfaces.IGrid;
import net.sf.latexdraw.glib.models.interfaces.IGroup;
import net.sf.latexdraw.glib.models.interfaces.IPicture;
import net.sf.latexdraw.glib.models.interfaces.IPolygon;
import net.sf.latexdraw.glib.models.interfaces.IPolyline;
import net.sf.latexdraw.glib.models.interfaces.IRectangle;
import net.sf.latexdraw.glib.models.interfaces.IRhombus;
import net.sf.latexdraw.glib.models.interfaces.IShapeFactory;
import net.sf.latexdraw.glib.models.interfaces.ISquare;
import net.sf.latexdraw.glib.models.interfaces.IText;
import net.sf.latexdraw.glib.models.interfaces.ITriangle;

import org.junit.Before;
import org.junit.Test;

public class TestLShapeFactory extends TestCase{
	@Override
	@Before
	public void setUp() {
		DrawingTK.setFactory(new LShapeFactory());
	}


	@Test
	public void testNewShape() {
		IShapeFactory factory = DrawingTK.getFactory();
		assertNotNull(factory.newShape(IRectangle.class));
		assertNotNull(factory.newShape(IPolyline.class));
		assertNotNull(factory.newShape(IBezierCurve.class));
		assertNotNull(factory.newShape(IDot.class));
		assertNotNull(factory.newShape(IFreehand.class));
		assertNotNull(factory.newShape(IGrid.class));
		assertNotNull(factory.newShape(IGroup.class));
		assertNotNull(factory.newShape(IPicture.class));
		assertNotNull(factory.newShape(IAxes.class));
		assertNotNull(factory.newShape(IPolygon.class));
		assertNotNull(factory.newShape(IRhombus.class));
		assertNotNull(factory.newShape(ITriangle.class));
		assertNotNull(factory.newShape(IFreehand.class));
		assertNotNull(factory.newShape(IEllipse.class));
		assertNotNull(factory.newShape(ICircle.class));
		assertNotNull(factory.newShape(ICircleArc.class));
		assertNotNull(factory.newShape(IGroup.class));
		assertNotNull(factory.newShape(IText.class));
		assertNotNull(factory.newShape(ISquare.class));
		assertNotNull(factory.newShape(IRectangle.class));
		assertNotNull(factory.newShape(IPolyline.class));
		assertNotNull(factory.newShape(IBezierCurve.class));
		assertNotNull(factory.newShape(IDot.class));
		assertNotNull(factory.newShape(IFreehand.class));
		assertNotNull(factory.newShape(IGrid.class));
		assertNotNull(factory.newShape(IGroup.class));
		assertNotNull(factory.newShape(IPicture.class));
		assertNotNull(factory.newShape(IAxes.class));
		assertNotNull(factory.newShape(IPolygon.class));
		assertNotNull(factory.newShape(IRhombus.class));
		assertNotNull(factory.newShape(ITriangle.class));
		assertNotNull(factory.newShape(IFreehand.class));
		assertNotNull(factory.newShape(IEllipse.class));
		assertNotNull(factory.newShape(ICircle.class));
		assertNotNull(factory.newShape(ICircleArc.class));
		assertNotNull(factory.newShape(IGroup.class));
		assertNotNull(factory.newShape(IText.class));
		assertNotNull(factory.newShape(ISquare.class));
		assertNull(factory.newShape(null));
	}
}
