package test.glib.models;


import net.sf.latexdraw.glib.models.impl.LShapeFactory;
import net.sf.latexdraw.glib.models.interfaces.DrawingTK;
import net.sf.latexdraw.glib.models.interfaces.ISquare;

import org.junit.Before;
import org.junit.Test;

import test.glib.models.interfaces.TestISquare;

public class TestLSquare<T extends ISquare> extends TestISquare<T> {
	@SuppressWarnings("unchecked")
	@Override
	@Before
	public void setUp() {
		DrawingTK.setFactory(new LShapeFactory());
		shape = (T) DrawingTK.getFactory().createSquare(false);
		shape2 = (T) DrawingTK.getFactory().createSquare(false);
	}



	@Test
	public void testConstructors() {
		ISquare sq = DrawingTK.getFactory().createSquare(false);
		assertEquals(4, sq.getNbPoints());

		try {
			sq = DrawingTK.getFactory().createSquare(null, 10, true);
			fail();
		}catch(IllegalArgumentException ex) { /* */ }
		try {
			sq = DrawingTK.getFactory().createSquare(DrawingTK.getFactory().createPoint(Double.NaN, 0), 10, true);
			fail();
		}catch(IllegalArgumentException ex) { /* */ }
		try {
			sq = DrawingTK.getFactory().createSquare(DrawingTK.getFactory().createPoint(), 0, true);
			fail();
		}catch(IllegalArgumentException ex) { /* */ }
		try {
			sq = DrawingTK.getFactory().createSquare(DrawingTK.getFactory().createPoint(), -10, true);
			fail();
		}catch(IllegalArgumentException ex) { /* */ }
		try {
			sq = DrawingTK.getFactory().createSquare(DrawingTK.getFactory().createPoint(), Double.NaN, true);
			fail();
		}catch(IllegalArgumentException ex) { /* */ }
		try {
			sq = DrawingTK.getFactory().createSquare(DrawingTK.getFactory().createPoint(), Double.POSITIVE_INFINITY, true);
			fail();
		}catch(IllegalArgumentException ex) { /* */ }
		try {
			sq = DrawingTK.getFactory().createSquare(DrawingTK.getFactory().createPoint(), Double.NEGATIVE_INFINITY, true);
			fail();
		}catch(IllegalArgumentException ex) { /* */ }

		sq = DrawingTK.getFactory().createSquare(DrawingTK.getFactory().createPoint(20, 26), 11, true);
		assertEquals(20., sq.getPosition().getX());
		assertEquals(37., sq.getPosition().getY());
		assertEquals(11., sq.getWidth());
		assertEquals(11., sq.getHeight());
	}
}
