package test.glib.models;


import net.sf.latexdraw.glib.models.impl.LShapeFactory;
import net.sf.latexdraw.glib.models.interfaces.DrawingTK;
import net.sf.latexdraw.glib.models.interfaces.IText;

import org.junit.Before;
import org.junit.Test;

import test.glib.models.interfaces.TestIText;

public class TestLText<T extends IText> extends TestIText<T> {
	@SuppressWarnings("unchecked")
	@Override
	@Before
	public void setUp() {
		DrawingTK.setFactory(new LShapeFactory());
		shape  = (T) DrawingTK.getFactory().createText(false);
		shape2 = (T) DrawingTK.getFactory().createText(false);
	}


	@Test
	public void testConstructors() {
		IText txt = DrawingTK.getFactory().createText(false);

		assertNotNull(txt.getText());
		assertTrue(txt.getText().length()>0);
		txt = DrawingTK.getFactory().createText(true);

		assertNotNull(txt.getText());
		assertTrue(txt.getText().length()>0);
		txt = DrawingTK.getFactory().createText(true, DrawingTK.getFactory().createPoint(), "coucou");

		assertNotNull(txt.getText());
		assertTrue(txt.getText().length()>0);
		txt = DrawingTK.getFactory().createText(true, DrawingTK.getFactory().createPoint(), "");

		assertNotNull(txt.getText());
		assertTrue(txt.getText().length()>0);
		txt = DrawingTK.getFactory().createText(true, DrawingTK.getFactory().createPoint(), null);

		assertNotNull(txt.getText());
		assertTrue(txt.getText().length()>0);

		txt = DrawingTK.getFactory().createText(false, null, "aa");
		assertEquals(DrawingTK.getFactory().createPoint(), txt.getPosition());
		txt = DrawingTK.getFactory().createText(false, DrawingTK.getFactory().createPoint(0, Double.NEGATIVE_INFINITY), "aa");
		assertEquals(DrawingTK.getFactory().createPoint(), txt.getPosition());
	}
}
